/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    stm32f0xx_it.c
  * @brief   Interrupt Service Routines.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f0xx_it.h"
/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "ssd1306.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN TD */

/* USER CODE END TD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */
uint32_t pulse_width;
uint8_t flag,direction;
volatile float distance;
char display_direction[16];
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/* External variables --------------------------------------------------------*/
extern TIM_HandleTypeDef htim16;
/* USER CODE BEGIN EV */
extern TIM_HandleTypeDef htim17;
/* USER CODE END EV */

/******************************************************************************/
/*           Cortex-M0 Processor Interruption and Exception Handlers          */
/******************************************************************************/
/**
  * @brief This function handles Non maskable interrupt.
  */
void NMI_Handler(void)
{
  /* USER CODE BEGIN NonMaskableInt_IRQn 0 */

  /* USER CODE END NonMaskableInt_IRQn 0 */
  /* USER CODE BEGIN NonMaskableInt_IRQn 1 */
   while (1)
  {
  }
  /* USER CODE END NonMaskableInt_IRQn 1 */
}

/**
  * @brief This function handles Hard fault interrupt.
  */
void HardFault_Handler(void)
{
  /* USER CODE BEGIN HardFault_IRQn 0 */

  /* USER CODE END HardFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_HardFault_IRQn 0 */
    /* USER CODE END W1_HardFault_IRQn 0 */
  }
}

/**
  * @brief This function handles System service call via SWI instruction.
  */
void SVC_Handler(void)
{
  /* USER CODE BEGIN SVC_IRQn 0 */

  /* USER CODE END SVC_IRQn 0 */
  /* USER CODE BEGIN SVC_IRQn 1 */

  /* USER CODE END SVC_IRQn 1 */
}

/**
  * @brief This function handles Pendable request for system service.
  */
void PendSV_Handler(void)
{
  /* USER CODE BEGIN PendSV_IRQn 0 */

  /* USER CODE END PendSV_IRQn 0 */
  /* USER CODE BEGIN PendSV_IRQn 1 */

  /* USER CODE END PendSV_IRQn 1 */
}

/**
  * @brief This function handles System tick timer.
  */
void SysTick_Handler(void)
{
  /* USER CODE BEGIN SysTick_IRQn 0 */

  /* USER CODE END SysTick_IRQn 0 */
  HAL_IncTick();
  /* USER CODE BEGIN SysTick_IRQn 1 */

  /* USER CODE END SysTick_IRQn 1 */
}

/******************************************************************************/
/* STM32F0xx Peripheral Interrupt Handlers                                    */
/* Add here the Interrupt Handlers for the used peripherals.                  */
/* For the available peripheral interrupt handler names,                      */
/* please refer to the startup file (startup_stm32f0xx.s).                    */
/******************************************************************************/

/**
  * @brief This function handles EXTI line 4 to 15 interrupts.
  */
void EXTI4_15_IRQHandler(void)
{
  /* USER CODE BEGIN EXTI4_15_IRQn 0 */
  if(flag)
  {
    pulse_width=TIM17 -> CNT ;
    pulse_width=pulse_width/200; // since it reflect
    distance=(3.43*pulse_width); // Distance in cm  
    switch(direction)
    {
        case 1: sprintf(display_direction,"West:%.2fcm   ",distance);
        OLCD_write_string(2,0,display_direction);
        break;
        case 2: sprintf(display_direction,"SW:%.2fcm    ",distance);
        OLCD_write_string(2,0,display_direction);
        break;
        case 3: sprintf(display_direction,"South:%.2fcm  ",distance);
        OLCD_write_string(2,0,display_direction);
        break;
        case 4: sprintf(display_direction,"WE:%.2fcm   ",distance);
        OLCD_write_string(2,0,display_direction);
        break;
        case 0: sprintf(display_direction,"East:%.2fcm   ",distance);
        OLCD_write_string(2,0,display_direction);
        break;
    }
    TIM17->CNT=0;
    flag=0;
  }
  else
  {
   HAL_TIM_Base_Start(&htim17);
   flag=1;
   TIM17->CNT=0;
  }
  /* USER CODE END EXTI4_15_IRQn 0 */
  HAL_GPIO_EXTI_IRQHandler(GPIO_PIN_9);
  /* USER CODE BEGIN EXTI4_15_IRQn 1 */

  /* USER CODE END EXTI4_15_IRQn 1 */
}

/**
  * @brief This function handles TIM16 global interrupt.
  */
void TIM16_IRQHandler(void)
{
  /* USER CODE BEGIN TIM16_IRQn 0 */
switch(direction)
    {
        case 0: TIM1->CCR1=499;      // West side
			 for(uint16_t j=0;j<8000;j++)
         for(uint16_t i=0;i<4800;i++)   // .8s
          __ASM volatile ("NOP");   // F_CPU=48MHz and every cycle 0.020833us time 
        break;
        case 1: TIM1->CCR1=999;      // South-West side
        break;
        case 2: TIM1->CCR1=1499;    // South side
        break;
        case 3: TIM1->CCR1=1999;    // South-East side
        break;
        case 4: TIM1->CCR1=2499;    // East side
        break;
    }
	for(uint16_t j=0;j<8000;j++)
     for(uint16_t i=0;i<480;i++)   // .8s
          __ASM volatile ("NOP");   // F_CPU=48MHz and every cycle 0.020833us time 
  direction++;
  if(direction>=5) direction=0;     //
	HAL_GPIO_WritePin(GPIOC,GPIO_PIN_9,GPIO_PIN_SET);
  for(uint16_t i=0;i<780;i++)
  __ASM volatile ("NOP");     //F_CPU=48MHz and every cycle 0.020833us time 
  HAL_GPIO_WritePin(GPIOC,GPIO_PIN_9,GPIO_PIN_RESET);
  /* USER CODE END TIM16_IRQn 0 */
  HAL_TIM_IRQHandler(&htim16);
  /* USER CODE BEGIN TIM16_IRQn 1 */

  /* USER CODE END TIM16_IRQn 1 */
}

/* USER CODE BEGIN 1 */

/* USER CODE END 1 */
